
function x = invxlnx2_fast(y,xx,yy)
% Fast solving y = 1/x*log(1/x-1) for x, y can be a vector but not a matrix
% x is the change rate, y is I*lambda, where I is Fisher info

i_large = y>1000;
if sum(i_large(:)) > 0
    z = y(i_large)./log(y(i_large)-1);

    for j = 1 : 20
        z = y(i_large)./log(z-1);
    end
    x(i_large) = 1./z;
end

i_small = y<=1000;
if sum(i_small(:)) > 0
    z = y(i_small);
    N = numel(xx);
    M = numel(z);
    comparison = z(:)*ones(1,N) >= ones(M,1)*xx;
    ind = sum(comparison,2);
    x(i_small) = yy(ind) + (z'-xx(ind))./(xx(ind+1)-xx(ind)).*(yy(ind+1)-yy(ind));
end
