function betas = si_mipod( sigmas, mus, xs, alpha )
% continuous approach
% minimize D_KL between N(x, sigma) a (1-b)*N(floor(x),sigma)+beta*N
% returns embedding probabilities
%
% sigmas -- estimated stds of each element
% mus -- estimated means of each element
% xs -- values of each element
% alpha -- relative payload in nats per each!!! element

betas = zeros( size( sigmas ) );
if alpha == 0
    return
end

q_func = @(x) .5*ones(size(x)) - .5*erf(x./sqrt(2));

left = floor(xs);

left_int  = @(x,mu,sigma) q_func( (x-mu)./sigma ) - q_func( (x+.5-mu)./sigma );
right_int = @(x,mu,sigma) q_func( (x+.5-mu)./sigma ) - q_func( (x+1-mu)./sigma );

Q_left = left_int(left, mus, sigmas);
Q_right = right_int(left, mus, sigmas);
Qs = Q_left + Q_right;
% Q_left = Q_left ./ Qs;
Q_right = Q_right ./ Qs;

r = exp( (.5 - mus)./(sigmas.^2) );

Q_right( Qs == 0 ) = 1./(r( Qs == 0 )+1);

Q = Q_right;

I = (1-2*Q).^2 ./ (1-Q) ./ Q;

% In JPEG embedding, remember to take care of the 4
% problematic DCT modes!
% e = mus - round(mus);
% wet_mat = false(size(sigmas));
% wet_mat(1:8:end, 1:8:end) = true;
% wet_mat(5:8:end, 1:8:end) = true;
% wet_mat(1:8:end, 5:8:end) = true;
% wet_mat(5:8:end, 5:8:end) = true;
% I(wet_mat & (abs(e)>0.4999)) = max(I(:)) * 100;

[betas, lambda] = betas_binary(I,alpha);
betas = reshape( betas, size(mus,1), size(mus,2) );
end